<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 30.30</title>
    <link rel="stylesheet" href="Task30.30.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="row desktop-1">
            <div class="col-7 form-input">
                <img class="image" src="Stroke 5.png">
                <h2 class="heading">Let’s get you started</h2>
                <form class="form" id="signUp-form">
                    <div class="form-group">
                        <label for="exampleInputFullName1" class="text">Full name</label>
                        <input type="text" class="form-control text" id="exampleInputFullName1" placeholder="Fullname">
                    </div>
                    <div class="form-group">
                        <label for="exampleInputEmail1" class="text">Email address</label>
                        <input type="email" class="form-control text" id="exampleInputEmail1" aria-describedby="emailHelp"
                            placeholder="Enter email">
                    </div>
                    <div class="form-group">
                        <label for="exampleInputPassword1" class="text">Create Password</label>
                        <input type="password" class="form-control text" id="exampleInputPassword1" placeholder="Password">
                        <div class="invalid-feedback">
                            Password must contain at least one symbol e.g. @, !
                        </div>
                        <div class="invalid-feedback">
                            Password must contain a minimum of 8 characters
                        </div>
                    </div>
                    <button type="submit" class="btn text-white bg-dark form-control">Sign Up</button>
                    <div class="Bottom-Title">
                        <p class="text-center text-muted" style="margin-top: 40px;">Already a user?
                            <a class="text-dark">Login</a>
                        </p>
                    </div>
                </form>
            </div>
            <div class="col-5 form-content">
                <div class="text-image">
                    <h1 class="text-light h1">“Creativity is intelligence having fun”</h1>
                    <p class="text-light p">- Albert Einstein</p>
                </div>
            </div>
    </div>

</body>

<script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
    var gSignUpFormElement = document.getElementById("signUp-form");

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    gSignUpFormElement.addEventListener("submit", function (paramEvent) {
        paramEvent.preventDefault();
        SignUp();
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //Hàm gọi API
    function SignUp() {
        // khai báo đối tượng
        var vPersonObj = {
            fullname: "",
            email: "",
            password: ""
        };
        //B1: thu thập dữ liệu
        thuThapDuLieu(vPersonObj);
        //B2: kiểm tra dữ liệu
        var vDuLieuHopLe = validateDataSignUp(vPersonObj);
        if (vDuLieuHopLe) {
            //B3: gọi API
            callAPISignUp(vPersonObj);
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm thu thập dữ liệu
    function thuThapDuLieu(paramPersonObj) {
        var vFullNameInput = document.getElementById("exampleInputFullName1");
        var vEmailInput = document.getElementById("exampleInputEmail1");
        var vPasswordInput = document.getElementById("exampleInputPassword1");


        paramPersonObj.fullname = vFullNameInput.value.trim();
        paramPersonObj.email = vEmailInput.value.trim();
        paramPersonObj.password = vPasswordInput.value.trim();
    }
    //Hàm kiểm tra dữ liệu input
    function validateDataSignUp(paramPersonObj) {
        if (paramPersonObj.fullname === "") {
            alert("FullName không được để trống");
            return false;
        }
        if (!paramPersonObj.email.includes("@")) {
            alert("Email không đúng định dạng");
            return false;
        }
        if (paramPersonObj.password.length < 8) {
            alert("Password phải có từ 8 kí tự trở lên");
            return false;
        }
        return true;
    }
    //Gọi API
    function callAPISignUp(paramPersonObj) {
        var vDataInput = JSON.stringify(paramPersonObj);
        var vXmlHttpSignUp = new XMLHttpRequest();
        vXmlHttpSignUp.open("POST", gBASE_URL, true);
        vXmlHttpSignUp.send(vDataInput);
        vXmlHttpSignUp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_CREATED) {
                var vSignupResponseText = vXmlHttpSignUp.responseText;
                var vInFo = JSON.parse(vSignupResponseText);
                console.log(vInFo);
                //B4: Hiển thị thông tin
                if (vInFo.length > 0) {
                    alert("Thành công");
                }
                else {
                    alert("Không thành công");
                }
            }
        }
    }


</script>

</html>